﻿#ifndef TEST_OK_COMMON_H
#define TEST_OK_COMMON_H

#include <android/log.h>
#include <jni.h>
#include <time.h>
#include <stdlib.h>
#include <string>

#define HAS_LOG 1
#ifdef HAS_LOG
    #define LOG    "ocr_sdk_jni" // 这个是自定义的LOG的标识
    #define LOGD(...)  __android_log_print(ANDROID_LOG_DEBUG,LOG,__VA_ARGS__) // 定义LOGD类型
    #define LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG,__VA_ARGS__) // 定义LOGI类型
    #define LOGW(...)  __android_log_print(ANDROID_LOG_WARN,LOG,__VA_ARGS__) // 定义LOGW类型
    #define LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG,__VA_ARGS__) // 定义LOGE类型
    #define LOGF(...)  __android_log_print(ANDROID_LOG_FATAL,LOG,__VA_ARGS__) // 定义LOGF类型
#else
    #define LOGD(...)
    #define LOGI(...)
    #define LOGW(...)
    #define LOGE(...)
    #define LOGF(...)
#endif

#define MIN(x, y) (x<y ? x : y)
#define MAX(x, y) (x>y ? x : y)

long clock_time();
std::string jstringToPChar(JNIEnv *env, jstring js, const char* encode="gbk");
jstring cstrToJstring(JNIEnv *env, const char *instr, const char* encode="gbk");

void initHashMap(JNIEnv *env, jclass &class_hashmap, jmethodID *hashmap_init, jmethodID *hashMap_put, jmethodID *hashMap_get);
void putMapOjbect(JNIEnv *env, jobject hashMap, jmethodID hashMap_put, const char* key, jobject obj);

void putMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_put, const char* key, const char* value);
void putMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_put, const char* key, int value);
void putMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_put, const char *key, long value);
void putMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_put, const char* key, float value);

bool getMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_get, std::string& value, const char *key);
bool getMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_get, int& value, const char *key);
bool getMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_get, long& value, const char *key);
bool getMapValue(JNIEnv *env, jobject hashMap, jmethodID hashMap_get, float& value, const char *key);

#endif //TEST_OK_COMMON_H
