/*
 * Copyright (c) 2014 Spotify AB
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#include "FaceLiving.h"

FaceLiving::FaceLiving() : JavaClass() {

}

//FaceLiving::FaceLiving(JNIEnv *env, cw_face_living_t *face) : JavaClass(env) {
//
//
//    keyptScore = face->keypt.keyptScore;
//    alignedW = face->faceAligned.width;
//    alignedH = face->faceAligned.height;
//    nChannels = face->faceAligned.nChannels;
//
//    code = face->code;
//    iAction = face->iAction;
//
//    pitch = face->angle.pitch;
//    yaw = face->angle.yaw;
//    roll = face->angle.roll;
//
//    //这里注意用false是使用的内部引用的方式.
//
//    float x[CW_MAX_FACE_KEYPT_NUM], y[CW_MAX_FACE_KEYPT_NUM];
//    int iSize = (face->keypt.nkeypt >= CW_MAX_FACE_KEYPT_NUM) ? CW_MAX_FACE_KEYPT_NUM
//                                                              : face->keypt.nkeypt;
//    for (int i = 0; i < iSize; i++) {
//        x[i] = face->keypt.points[i].x;
//        y[i] = face->keypt.points[i].y;
//    }
//    keypt_x.set(x, iSize, true);
//    keypt_y.set(y, iSize, true);
//
//    alignedData.set(face->faceAligned.data,
//                    CW_ALIGNED_IMAGE_WH * CW_ALIGNED_IMAGE_WH * CW_ALIGNED_IMAGE_CHNS, true);
//
//
//    //copy float arry[]
//
//    initialize(env);
//    // Set up field mappings for the instance. Normally this isn't necessary,
//    // since the global instance is typically used for merging into other objects.
//    // If you want to actually use the initialized instance in combination with
//    // setJavaObject(), you should call this though.
//    merge(this);
//    //mapFileds();
//}

void FaceLiving::initialize(JNIEnv *env) {
    setClass(env);

    cacheField(env, "keyptScore", kTypeFloat);

    cacheField(env, "alignedW", kTypeInt);
    cacheField(env, "alignedH", kTypeInt);
    cacheField(env, "nChannels", kTypeInt);

    cacheField(env, "code", kTypeInt);
    cacheField(env, "iAction", kTypeInt);


    cacheField(env, "pitch", kTypeFloat);
    cacheField(env, "yaw", kTypeFloat);
    cacheField(env, "roll", kTypeFloat);

    cacheField(env, "keypt_x", kTypeArray(kTypeFloat));
    cacheField(env, "keypt_y", kTypeArray(kTypeFloat));
    cacheField(env, "alignedData", kTypeArray(kTypeByte));

}

void FaceLiving::mapFields() {

    LOG_DEBUG("mapFileds");
    mapField("keyptScore", kTypeFloat, &keyptScore);

    mapField("alignedW", kTypeInt, &alignedW);
    mapField("alignedH", kTypeInt, &alignedH);
    mapField("nChannels", kTypeInt, &nChannels);

    mapField("code", kTypeInt, &code);
    mapField("iAction", kTypeInt, &iAction);

    mapField("pitch", kTypeFloat, &pitch);
    mapField("yaw", kTypeFloat, &yaw);
    mapField("roll", kTypeFloat, &roll);

    mapField("keypt_x", kTypeArray(kTypeFloat), &keypt_x);
    mapField("keypt_y", kTypeArray(kTypeFloat), &keypt_y);
    mapField("alignedData", kTypeArray(kTypeByte), &alignedData);
}
